software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Models/Project.cs
using System.ComponentModel.DataAnnotations;

namespace ProjectRider.Models
{
    public class Project
    {
        //TODO: Implement me ...
        [Key]
        public int Id { get; set; }

        [Required]
        [MinLength(1)]
        public string Title { get; set; }

        [Required]
        [MinLength(1)]
        public string Description{ get; set; }


        [Required]
        public long Budget { get; set; }

    }
}

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Models/ProjectRiderDbContext.cs
using System.Data.Entity;

namespace ProjectRider.Models
{
    public class ProjectRiderDbContext : DbContext
    {
        public virtual IDbSet<Project> Projects { get; set; }

        public ProjectRiderDbContext() : base("ProjectRider")
        {
        }
    }
}

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Controllers/ProjectController.cs
namespace ProjectRider.Controllers
{
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Mvc;
    using Models;

    [ValidateInput(false)]
    public class ProjectController : Controller
    {

        private ProjectRiderDbContext db = new ProjectRiderDbContext();

        [HttpGet]
        [Route("")]
        public ActionResult Index()
        {
            var projects = db.Projects.ToList();
            return View(projects);
        }

        [HttpGet]
        [Route("create")]
        public ActionResult Create()
        {
            //TODO: Implement me ...
            return View(new Project());
        }

        [HttpPost]
        [Route("create")]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Project project)
        {
            //TODO: Implement me ...
            if (this.ModelState.IsValid)
            {
                db.Projects.Add(project);
                db.SaveChanges();
                return Redirect("/");
            }

            return View(project);
        }

        [HttpGet]
        [Route("edit/{id}")]
        public ActionResult Edit(int id)
        {
            //TODO: Implement me ...

            var project = db.Projects.Find(id);

            if (project == null)
            {
                return HttpNotFound();
            }
            return View(project);
        }

        [HttpPost]
        [Route("edit/{id}")]
        [ValidateAntiForgeryToken]
        public ActionResult EditConfirm(int id, Project project)
        {
            //TODO: Implement me ...

            var projectFromDb = db.Projects.Find(id);

            if (projectFromDb == null)
            {
                return HttpNotFound();
            }

            if (this.ModelState.IsValid)
            {
                projectFromDb.Title = project.Title;
                projectFromDb.Description = project.Description;
                projectFromDb.Budget = project.Budget;
                db.SaveChanges();

                return Redirect("/");
            }
            return View("Edit", project);
        }

        [HttpGet]
        [Route("delete/{id}")]
        public ActionResult Delete(int id)
        {
            //TODO: Implement me ...

            var project = db.Projects.Find(id);

            if (project == null)
            {
                return HttpNotFound();
            }
            return View(project);
        }

        [HttpPost]
        [Route("delete/{id}")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirm(int id, Project reportModel)
        {
            //TODO: Implement me ...

            var projectFromDb = db.Projects.Find(id);
            if (projectFromDb == null)
                return HttpNotFound();

            db.Projects.Remove(projectFromDb);
            db.SaveChanges();

            return Redirect("/");
        }
    }
}

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Views/Project/Create.cshtml
@model ProjectRider.Models.Project

@{
    ViewBag.Title = "Create";
}

<div class="wrapper">
    @using (Html.BeginForm("Create", "Project", FormMethod.Post, new { @class = "project-create" }))
    {
        @Html.AntiForgeryToken()
        <div class="create-header">
            Create Project
        </div>
        <div class="create-title">
            <div class="create-title-label">Title</div>
            <input class="create-title-content" name="title" />
        </div>
        <div class="create-description">
            <div class="create-description-label">Description</div>
            <textarea rows="3" class="create-description-content" name="description"></textarea>
        </div>
        <div class="create-budget">
            <div class="create-budget-label">Budget</div>
            <input type="number" min="0" class="create-budget-content" name="budget" />
        </div>
        <div class="create-button-holder">
            <button type="submit" class="submit-button">Create Project</button>
            <a type="button" href="/" class="back-button">Back</a>
        </div>
    }
</div>

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Views/Project/Delete.cshtml
@model ProjectRider.Models.Project

@{
    ViewBag.Title = "Delete";
}

<div class="wrapper">
    @using (Html.BeginForm("Delete", "Project", FormMethod.Post, new { @class="project-create"} ))
    {
        @Html.AntiForgeryToken()
        <div class="create-header">
            Delete Project
        </div>
        <div class="create-title">
            <div class="create-title-label">Title</div>
            <input class="create-title-content" name="title" value="@Model.Title" disabled="disabled"/>
        </div>
        <div class="create-description">
            <div class="create-description-label">Description</div>
            <textarea rows="3" class="create-description-content" name="description" disabled="disabled">@Model.Description</textarea>
        </div>
        <div class="create-budget">
            <div class="create-budget-label">Budget</div>
            <input type="number" min="0" class="create-budget-content" name="budget" value="@Model.Budget" disabled="disabled"/>
        </div>
        <div class="create-button-holder">
            <button type="submit" class="submit-button">Delete Project</button>
            <a type="button" href="/" class="back-button">Back</a>
        </div>
    }
</div>

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Views/Project/Edit.cshtml
@model ProjectRider.Models.Project

@{
    ViewBag.Title = "Edit";
}

<div class="wrapper">
    @using (Html.BeginForm("Edit", "Project", FormMethod.Post, new { @class = "project-create" }))
    {
        @Html.AntiForgeryToken()
        <div class="create-header">
            Edit Project
        </div>
        <div class="create-title">
            <div class="create-title-label">Title</div>
            <input class="create-title-content" name="title" value="@Model.Title" />
        </div>
        <div class="create-description">
            <div class="create-description-label">Description</div>
            <textarea rows="3" class="create-description-content" name="description">@Model.Description</textarea>
        </div>
        <div class="create-budget">
            <div class="create-budget-label">Budget</div>
            <input type="number" min="0" class="create-budget-content" name="budget" value="@Model.Budget" />
        </div>
        <div class="create-button-holder">
            <button type="submit" class="submit-button">Edit Project</button>
            <a type="button" href="/" class="back-button">Back</a>
        </div>
    }
</div>

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Views/Project/Index.cshtml
@model List<ProjectRider.Models.Project>

@{
	ViewBag.Title = "Index";
}
<div class="wrapper">
    <div class="button-holder">
        <a type="button" href="/create" class="log-button">Create New Project</a>
    </div>
    <div class="content">
        <div class="header">
            <div class="project-label">Project</div>
            <div class="budget-label">Budget</div>
            <div class="actions-label">Actions</div>
        </div>
        <div class="main">
            @foreach (var project in Model.ToList())
            {
                <div class="project">
                    <div class="project-title">
                        @(project.Title)
                    </div>
                    <div class="project-budget">
                        @(project.Budget)
                    </div>
                    <div class="project-actions">
                        @Html.ActionLink("Edit", "Edit", "Project", new { id = project.Id }, new { @class = "edit-button" })
                        @Html.ActionLink("Delete", "Delete", "Project", new { id = project.Id }, new { @class = "delete-button" })
                    </div>
                </div>
            }
        </div>
    </div>
</div>

software-technologies-exam/Skeletons/C#-Skeleton/ProjectRider/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
	<title>ProjectRider</title>
	@Styles.Render("~/Content/reset.css")
	@Styles.Render("~/Content/style.css")
	@Styles.Render("~/Content/create-style.css")
</head>
<body>
	@RenderBody()
</body>
</html>